#include "stdafx.h"
#include "stdio.h"
#include "writebmp.h"

void writefileheader(FILE *fp, unsigned int height,unsigned int width)
{

 char buffer[40];
 unsigned char c;
 unsigned int i,l,m;

 strcpy(buffer,"BM");
 fwrite(buffer,1,2,fp);
 l=(((width*3)+3)/4)*4;
 l=(l*height)+54;
 for (i=0; i<4; i++)
  {
	m=(l & 255);
	c=(unsigned char)(m);
	fwrite(&c,1,1,fp);
	l=l >> 8;
  }
 for (i=0; i<4; i++)
  {
	c=0;
	fwrite(&c,1,1,fp);
  }
 c=54;
 fwrite(&c,1,1,fp);
 for (i=0; i<3; i++)
  {
	c=0;
	fwrite(&c,1,1,fp);
  }
 c=40;
 fwrite(&c,1,1,fp);
 for (i=0; i<3; i++)
  {
	c=0;
	fwrite(&c,1,1,fp);
  }
 l=width;
 for (i=0; i<4; i++)
  {
	m=(l & 255);
	c=(unsigned char)(m);
	fwrite(&c,1,1,fp);
	l=l >> 8;
  }
 l=height;
 for (i=0; i<4; i++)
  {
	m=(l & 255);
	c=(unsigned char)(m);
	fwrite(&c,1,1,fp);
	l=l >> 8;
  }
 c=1;
 fwrite(&c,1,1,fp);
 c=0;
 fwrite(&c,1,1,fp);
 c=24;
 fwrite(&c,1,1,fp);
 for (i=0; i<5; i++)
  {
	c=0;
	fwrite(&c,1,1,fp);
  }
 l=(((width*3)+3)/4)*4;
 l=(l*height);
 for (i=0; i<4; i++)
  {
	m=(l & 255);
	c=(unsigned char)(m);
	fwrite(&c,1,1,fp);
	l=l >> 8;
  }
 for (i=0; i<16; i++)
  {
	c=0;
	fwrite(&c,1,1,fp);
  }
}

void writebody(COLORREF *array,unsigned int height,unsigned int width, FILE *fp)
{
 BYTE blu, grn, red;
 unsigned int loop_i,loop_j;
 unsigned int grid_index_a,grid_index_b;
 unsigned int data_width;
 unsigned int num_pad_bytes,blank=0;

 data_width=(((width*3)+3)/4)*4;
 num_pad_bytes=data_width-(3*width);
 for ( loop_i=height; loop_i>0; loop_i-- )
 {
	 grid_index_a = (loop_i-1) * width;
	 for(loop_j=0; loop_j<width; loop_j++ )
	 {
		 grid_index_b = grid_index_a + loop_j;
		 blu=GetBValue(array[grid_index_b]);
		 grn=GetGValue(array[grid_index_b]);
		 red=GetRValue(array[grid_index_b]);
		 fwrite(&blu,1,1,fp);
		 fwrite(&grn,1,1,fp);
		 fwrite(&red,1,1,fp);
	 }
	 if (num_pad_bytes != 0)
	 {
		 for ( loop_j=0; loop_j<num_pad_bytes; loop_j++ )
		 {
			 fwrite(&blank,1,1,fp);
		 }
	 }
 }
}
