// oh_joyDoc.cpp : implementation of the COh_joyDoc class
//

#include "stdafx.h"
#include "oh_joy.h"
#include "stdio.h"
#include "string.h"

#include "oh_joyDoc.h"
#include "Settings.h"
#include "writebmp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COh_joyDoc

IMPLEMENT_DYNCREATE(COh_joyDoc, CDocument)

BEGIN_MESSAGE_MAP(COh_joyDoc, CDocument)
	//{{AFX_MSG_MAP(COh_joyDoc)
	ON_COMMAND(ID_ACTIONS_SETPARAMETERS, OnActionsSetparameters)
	ON_COMMAND(ID_FILE_SAVEBMP, OnFileSavebmp)
	ON_COMMAND(ID_FILE_SAVEBMPAS, OnFileSavebmpas)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVEBMP, OnUpdateFileSavebmp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COh_joyDoc construction/destruction

/*
GetBValue  
GetGValue  
GetRValue  
PALETTEINDEX  
PALETTERGB  
RGB 
*/

COh_joyDoc::COh_joyDoc()
{
	// TODO: add one-time construction code here
	m_BMP_File_Name="";
	m_bmp_save_flag=false;
	m_Grid = new COLORREF[480000];
	for ( loop_i=0; loop_i<480000; loop_i++ )
	{
		m_Grid[loop_i]=(RGB(0,0,0));
	}
	m_Render_width = 800;
	m_Render_height = 600;
	m_A=.3;
	m_B=.3;
	m_C=.3;
	m_D=.3;
	m_E=.3;
	m_F=0.0;
	m_Init_x=0.0;
	m_Init_y=0.0;
	m_Iteration=10000;
	m_Top=5;
	m_Left=-5;
	m_Bottom=-5;
	m_Right=5;
	m_color_1=RGB(255,255,255);
	m_color_2=RGB(0,0,255);
	m_color_3=RGB(255,255,0);
	m_color_4=RGB(255,0,0);
	m_plot_mode="Overwrite (Simple)";
	m_Formula="Hopalong Formula 1";
}

COh_joyDoc::~COh_joyDoc()
{
	delete m_Grid;
	m_Grid=0;
}

BOOL COh_joyDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	delete m_Grid;
	m_Grid=0;
	m_Grid = new COLORREF[480000];
	for ( loop_i=0; loop_i<480000; loop_i++ )
	{
		m_Grid[loop_i]=(RGB(0,0,0));
	}
	m_Render_width = 800;
	m_Render_height = 600;
	m_A=.3;
	m_B=.3;
	m_C=.3;
	m_D=.3;
	m_E=.3;
	m_F=0.0;
	m_Init_x=0.0;
	m_Init_y=0.0;
	m_Iteration=10000;
	m_Top=5;
	m_Left=-5;
	m_Bottom=-5;
	m_Right=5;
	m_color_1=RGB(255,255,255);
	m_color_2=RGB(0,0,255);
	m_color_3=RGB(255,255,0);
	m_color_4=RGB(255,0,0);
	m_plot_mode="Overwrite (Simple)";
	m_Formula="Hopalong Formula 1";

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// COh_joyDoc serialization

void COh_joyDoc::Serialize(CArchive& ar)
{
	int memsize;

	if (ar.IsStoring())
	{
		// TODO: add storing code here
		ar<<m_Render_width<<m_Render_height<<m_A<<m_B<<m_C<<m_D<<m_E<<m_F
			<<m_Init_x<<m_Init_y<<m_Iteration
				<<m_Top<<m_Left<<m_Bottom<<m_Right
					<<m_color_1<<m_color_2<<m_color_3<<m_color_4
						<<m_plot_mode<<m_Formula;
	}
	else
	{
		// TODO: add loading code here
		ar>>m_Render_width>>m_Render_height>>m_A>>m_B>>m_C>>m_D>>m_E>>m_F
			>>m_Init_x>>m_Init_y>>m_Iteration
				>>m_Top>>m_Left>>m_Bottom>>m_Right
					>>m_color_1>>m_color_2>>m_color_3>>m_color_4
						>>m_plot_mode>>m_Formula;

		memsize=m_Render_width*m_Render_height;
		delete m_Grid;
		m_Grid=0;
		m_Grid = new COLORREF[memsize];
		for ( loop_i=0; loop_i<memsize; loop_i++ )
		{
			m_Grid[loop_i]=(RGB(0,0,0));
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// COh_joyDoc diagnostics

#ifdef _DEBUG
void COh_joyDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void COh_joyDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COh_joyDoc commands



void COh_joyDoc::OnActionsSetparameters() 
{
	// TODO: Add your command handler code here
	int memsize;
	int render_width, render_height;
	CSettings SettingsDLG;

	render_width=m_Render_width;
	render_height=m_Render_height;

	SettingsDLG.m_A=m_A;
	SettingsDLG.m_B=m_B;
	SettingsDLG.m_C=m_C;
	SettingsDLG.m_D=m_D;
	SettingsDLG.m_E=m_E;
	SettingsDLG.m_F=m_F;
	SettingsDLG.m_Init_x=m_Init_x;
	SettingsDLG.m_Init_y=m_Init_y;
	SettingsDLG.m_Iteration=m_Iteration;
	SettingsDLG.m_Top=m_Top;
	SettingsDLG.m_Left=m_Left;
	SettingsDLG.m_Bottom=m_Bottom;
	SettingsDLG.m_Right=m_Right;
	SettingsDLG.m_color_1=m_color_1;
	SettingsDLG.m_color_2=m_color_2;
	SettingsDLG.m_color_3=m_color_3;
	SettingsDLG.m_color_4=m_color_4;
	SettingsDLG.m_plot_mode=m_plot_mode;
	SettingsDLG.m_Render_width=m_Render_width;
	SettingsDLG.m_Render_height=m_Render_height;
	SettingsDLG.m_Formula=m_Formula;

	if (SettingsDLG.DoModal()==IDOK)
	{
		m_A=SettingsDLG.m_A;
		m_B=SettingsDLG.m_B;
		m_C=SettingsDLG.m_C;
		m_D=SettingsDLG.m_D;
		m_E=SettingsDLG.m_E;
		m_F=SettingsDLG.m_F;
		m_Init_x=SettingsDLG.m_Init_x;
		m_Init_y=SettingsDLG.m_Init_y;
		m_Iteration=SettingsDLG.m_Iteration;
		m_Top=SettingsDLG.m_Top;
		m_Left=SettingsDLG.m_Left;
		m_Bottom=SettingsDLG.m_Bottom;
		m_Right=SettingsDLG.m_Right;
		m_color_1=SettingsDLG.m_color_1;
		m_color_2=SettingsDLG.m_color_2;
		m_color_3=SettingsDLG.m_color_3;
		m_color_4=SettingsDLG.m_color_4;
		m_plot_mode=SettingsDLG.m_plot_mode;
		m_Render_width=SettingsDLG.m_Render_width;
		m_Render_height=SettingsDLG.m_Render_height;
		m_Formula=SettingsDLG.m_Formula;
		if ((render_width!=m_Render_width)||(render_height!=m_Render_height))
		{
			memsize=m_Render_width*m_Render_height;
			delete m_Grid;
			m_Grid=0;
			m_Grid = new COLORREF[memsize];
			for ( loop_i=0; loop_i<memsize; loop_i++ )
			{
				m_Grid[loop_i]=(RGB(0,0,0));
			}
		}
	}
}

void COh_joyDoc::OnFileSavebmp() 
{
	// TODO: Add your command handler code here

	FILE *fp;

	fp=fopen(m_BMP_File_Name,"wb");
	writefileheader(fp,m_Render_height,m_Render_width);
	writebody(m_Grid,m_Render_height,m_Render_width,fp);
	fclose(fp);
}

void COh_joyDoc::OnFileSavebmpas() 
{
	// TODO: Add your command handler code here

	FILE *fp;

	CFileDialog CFile(false,"bmp",NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"Bitmap Files (*.bmp)|*.bmp||",NULL); 

	if (CFile.DoModal()==IDOK)
		m_BMP_File_Name=CFile.GetPathName();
	fp=fopen(m_BMP_File_Name,"wb");
	writefileheader(fp,m_Render_height,m_Render_width);
	writebody(m_Grid,m_Render_height,m_Render_width,fp);
	fclose(fp);
	m_bmp_save_flag=true;
}

void COh_joyDoc::OnUpdateFileSavebmp(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if (m_bmp_save_flag)
		pCmdUI->Enable(true);
	else
		pCmdUI->Enable(false);
}

