// oh_joyDoc.h : interface of the COh_joyDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_OH_JOYDOC_H__1931A919_8B5C_4D62_88EA_0EB8122CE784__INCLUDED_)
#define AFX_OH_JOYDOC_H__1931A919_8B5C_4D62_88EA_0EB8122CE784__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class COh_joyDoc : public CDocument
{
protected: // create from serialization only
	COh_joyDoc();
	DECLARE_DYNCREATE(COh_joyDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COh_joyDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	double m_Init_y;
	double m_Init_x;
	double m_F;
	CString m_Formula;
	CString	m_plot_mode;
	COLORREF m_color_1;
	COLORREF m_color_2;
	COLORREF m_color_3;
	COLORREF m_color_4;
	BOOL m_bmp_save_flag;
	CString m_BMP_File_Name;
	double m_A;
	double m_B;
	double m_C;
	double m_D;
	double m_E;
	int m_Iteration;
	double	m_Top;
	double	m_Left;
	double	m_Bottom;
	double	m_Right;
	int m_Render_height;
	int m_Render_width;
	int loop_i;
	COLORREF * m_Grid;
	virtual ~COh_joyDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(COh_joyDoc)
	afx_msg void OnActionsSetparameters();
	afx_msg void OnFileSavebmp();
	afx_msg void OnFileSavebmpas();
	afx_msg void OnUpdateFileSavebmp(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OH_JOYDOC_H__1931A919_8B5C_4D62_88EA_0EB8122CE784__INCLUDED_)
